-- btag32.vhd
-- generate the combinatorial inputs for the 32-bit block tag register.

-- jamieson olsen <jamieson@fnal.gov>
-- 1 july 1999
-- updated 9 Jan 2002 :
-- updated 4 Feb 2002 : change the block order inconsistancy.  Now it matches engineering note 2001-12-29.


library ieee;
use ieee.std_logic_1164.all;

entity btag32 is
    port (
        matrix_d: in    std_logic_vector(703 downto 0);
        blktag_d: out   std_logic_vector(31 downto 0)
    );
end btag32;

architecture blocktag32_arch of btag32 is

    -- no signal definitions

 begin

    -- combinatorial stuff



    blktag_d(31) <=     matrix_d(703) or
                        matrix_d(702) or
                        matrix_d(701) or
                        matrix_d(700) or
                        matrix_d(699) or
                        matrix_d(698) or
                        matrix_d(697) or
                        matrix_d(696) or
                        matrix_d(695) or
                        matrix_d(694) or
                        matrix_d(693) or
                        matrix_d(692) or
                        matrix_d(691) or
                        matrix_d(690) or
                        matrix_d(689) or
                        matrix_d(688) or
                        matrix_d(687) or
                        matrix_d(686) or
                        matrix_d(685) or
                        matrix_d(684) or
                        matrix_d(683) or
                        matrix_d(682);

    blktag_d(30) <=     matrix_d(681) or
                        matrix_d(680) or
                        matrix_d(679) or
                        matrix_d(678) or
                        matrix_d(677) or
                        matrix_d(676) or
                        matrix_d(675) or
                        matrix_d(674) or
                        matrix_d(673) or
                        matrix_d(672) or
                        matrix_d(671) or
                        matrix_d(670) or
                        matrix_d(669) or
                        matrix_d(668) or
                        matrix_d(667) or
                        matrix_d(666) or
                        matrix_d(665) or
                        matrix_d(664) or
                        matrix_d(663) or
                        matrix_d(662) or
                        matrix_d(661) or
                        matrix_d(660);

    blktag_d(29) <=     matrix_d(659) or
                        matrix_d(658) or
                        matrix_d(657) or
                        matrix_d(656) or
                        matrix_d(655) or
                        matrix_d(654) or
                        matrix_d(653) or
                        matrix_d(652) or
                        matrix_d(651) or
                        matrix_d(650) or
                        matrix_d(649) or
                        matrix_d(648) or
                        matrix_d(647) or
                        matrix_d(646) or
                        matrix_d(645) or
                        matrix_d(644) or
                        matrix_d(643) or
                        matrix_d(642) or
                        matrix_d(641) or
                        matrix_d(640) or
                        matrix_d(639) or
                        matrix_d(638);

    blktag_d(28) <=     matrix_d(637) or
                        matrix_d(636) or
                        matrix_d(635) or
                        matrix_d(634) or
                        matrix_d(633) or
                        matrix_d(632) or
                        matrix_d(631) or
                        matrix_d(630) or
                        matrix_d(629) or
                        matrix_d(628) or
                        matrix_d(627) or
                        matrix_d(626) or
                        matrix_d(625) or
                        matrix_d(624) or
                        matrix_d(623) or
                        matrix_d(622) or
                        matrix_d(621) or
                        matrix_d(620) or
                        matrix_d(619) or
                        matrix_d(618) or
                        matrix_d(617) or
                        matrix_d(616);

    blktag_d(27) <=     matrix_d(615) or
                        matrix_d(614) or
                        matrix_d(613) or
                        matrix_d(612) or
                        matrix_d(611) or
                        matrix_d(610) or
                        matrix_d(609) or
                        matrix_d(608) or
                        matrix_d(607) or
                        matrix_d(606) or
                        matrix_d(605) or
                        matrix_d(604) or
                        matrix_d(603) or
                        matrix_d(602) or
                        matrix_d(601) or
                        matrix_d(600) or
                        matrix_d(599) or
                        matrix_d(598) or
                        matrix_d(597) or
                        matrix_d(596) or
                        matrix_d(595) or
                        matrix_d(594);

    blktag_d(26) <=     matrix_d(593) or
                        matrix_d(592) or
                        matrix_d(591) or
                        matrix_d(590) or
                        matrix_d(589) or
                        matrix_d(588) or
                        matrix_d(587) or
                        matrix_d(586) or
                        matrix_d(585) or
                        matrix_d(584) or
                        matrix_d(583) or
                        matrix_d(582) or
                        matrix_d(581) or
                        matrix_d(580) or
                        matrix_d(579) or
                        matrix_d(578) or
                        matrix_d(577) or
                        matrix_d(576) or
                        matrix_d(575) or
                        matrix_d(574) or
                        matrix_d(573) or
                        matrix_d(572);

    blktag_d(25) <=     matrix_d(571) or
                        matrix_d(570) or
                        matrix_d(569) or
                        matrix_d(568) or
                        matrix_d(567) or
                        matrix_d(566) or
                        matrix_d(565) or
                        matrix_d(564) or
                        matrix_d(563) or
                        matrix_d(562) or
                        matrix_d(561) or
                        matrix_d(560) or
                        matrix_d(559) or
                        matrix_d(558) or
                        matrix_d(557) or
                        matrix_d(556) or
                        matrix_d(555) or
                        matrix_d(554) or
                        matrix_d(553) or
                        matrix_d(552) or
                        matrix_d(551) or
                        matrix_d(550);

    blktag_d(24) <=     matrix_d(549) or
                        matrix_d(548) or
                        matrix_d(547) or
                        matrix_d(546) or
                        matrix_d(545) or
                        matrix_d(544) or
                        matrix_d(543) or
                        matrix_d(542) or
                        matrix_d(541) or
                        matrix_d(540) or
                        matrix_d(539) or
                        matrix_d(538) or
                        matrix_d(537) or
                        matrix_d(536) or
                        matrix_d(535) or
                        matrix_d(534) or
                        matrix_d(533) or
                        matrix_d(532) or
                        matrix_d(531) or
                        matrix_d(530) or
                        matrix_d(529) or
                        matrix_d(528);

    blktag_d(23) <= matrix_d(527) or
                    matrix_d(526) or
                    matrix_d(525) or
                    matrix_d(524) or
                    matrix_d(523) or
                    matrix_d(522) or
                    matrix_d(521) or
                    matrix_d(520) or
                    matrix_d(519) or
                    matrix_d(518) or
                    matrix_d(517) or
                    matrix_d(516) or
                    matrix_d(515) or
                    matrix_d(514) or
                    matrix_d(513) or
                    matrix_d(512) or
                    matrix_d(511) or
                    matrix_d(510) or
                    matrix_d(509) or
                    matrix_d(508) or
                    matrix_d(507) or
                    matrix_d(506);

    blktag_d(22) <= matrix_d(505) or
                    matrix_d(504) or
                    matrix_d(503) or
                    matrix_d(502) or
                    matrix_d(501) or
                    matrix_d(500) or
                    matrix_d(499) or
                    matrix_d(498) or
                    matrix_d(497) or
                    matrix_d(496) or
                    matrix_d(495) or
                    matrix_d(494) or
                    matrix_d(493) or
                    matrix_d(492) or
                    matrix_d(491) or
                    matrix_d(490) or
                    matrix_d(489) or
                    matrix_d(488) or
                    matrix_d(487) or
                    matrix_d(486) or
                    matrix_d(485) or
                    matrix_d(484);

    blktag_d(21) <= matrix_d(483) or
                    matrix_d(482) or
                    matrix_d(481) or
                    matrix_d(480) or
                    matrix_d(479) or
                    matrix_d(478) or
                    matrix_d(477) or
                    matrix_d(476) or
                    matrix_d(475) or
                    matrix_d(474) or
                    matrix_d(473) or
                    matrix_d(472) or
                    matrix_d(471) or
                    matrix_d(470) or
                    matrix_d(469) or
                    matrix_d(468) or
                    matrix_d(467) or
                    matrix_d(466) or
                    matrix_d(465) or
                    matrix_d(464) or
                    matrix_d(463) or
                    matrix_d(462);

    blktag_d(20) <= matrix_d(461) or
                    matrix_d(460) or
                    matrix_d(459) or
                    matrix_d(458) or
                    matrix_d(457) or
                    matrix_d(456) or
                    matrix_d(455) or
                    matrix_d(454) or
                    matrix_d(453) or
                    matrix_d(452) or
                    matrix_d(451) or
                    matrix_d(450) or
                    matrix_d(449) or
                    matrix_d(448) or
                    matrix_d(447) or
                    matrix_d(446) or
                    matrix_d(445) or
                    matrix_d(444) or
                    matrix_d(443) or
                    matrix_d(442) or
                    matrix_d(441) or
                    matrix_d(440);

    blktag_d(19) <= matrix_d(439) or
                    matrix_d(438) or
                    matrix_d(437) or
                    matrix_d(436) or
                    matrix_d(435) or
                    matrix_d(434) or
                    matrix_d(433) or
                    matrix_d(432) or
                    matrix_d(431) or
                    matrix_d(430) or
                    matrix_d(429) or
                    matrix_d(428) or
                    matrix_d(427) or
                    matrix_d(426) or
                    matrix_d(425) or
                    matrix_d(424) or
                    matrix_d(423) or
                    matrix_d(422) or
                    matrix_d(421) or
                    matrix_d(420) or
                    matrix_d(419) or
                    matrix_d(418);

    blktag_d(18) <= matrix_d(417) or
                    matrix_d(416) or
                    matrix_d(415) or
                    matrix_d(414) or
                    matrix_d(413) or
                    matrix_d(412) or
                    matrix_d(411) or
                    matrix_d(410) or
                    matrix_d(409) or
                    matrix_d(408) or
                    matrix_d(407) or
                    matrix_d(406) or
                    matrix_d(405) or
                    matrix_d(404) or
                    matrix_d(403) or
                    matrix_d(402) or
                    matrix_d(401) or
                    matrix_d(400) or
                    matrix_d(399) or
                    matrix_d(398) or
                    matrix_d(397) or
                    matrix_d(396);

    blktag_d(17) <= matrix_d(395) or
                    matrix_d(394) or
                    matrix_d(393) or
                    matrix_d(392) or
                    matrix_d(391) or
                    matrix_d(390) or
                    matrix_d(389) or
                    matrix_d(388) or
                    matrix_d(387) or
                    matrix_d(386) or
                    matrix_d(385) or
                    matrix_d(384) or
                    matrix_d(383) or
                    matrix_d(382) or
                    matrix_d(381) or
                    matrix_d(380) or
                    matrix_d(379) or
                    matrix_d(378) or
                    matrix_d(377) or
                    matrix_d(376) or
                    matrix_d(375) or
                    matrix_d(374);

    blktag_d(16) <= matrix_d(373) or
                    matrix_d(372) or
                    matrix_d(371) or
                    matrix_d(370) or
                    matrix_d(369) or
                    matrix_d(368) or
                    matrix_d(367) or
                    matrix_d(366) or
                    matrix_d(365) or
                    matrix_d(364) or
                    matrix_d(363) or
                    matrix_d(362) or
                    matrix_d(361) or
                    matrix_d(360) or
                    matrix_d(359) or
                    matrix_d(358) or
                    matrix_d(357) or
                    matrix_d(356) or
                    matrix_d(355) or
                    matrix_d(354) or
                    matrix_d(353) or
                    matrix_d(352);


    blktag_d(15) <= matrix_d(351) or
                    matrix_d(350) or
                    matrix_d(349) or
                    matrix_d(348) or
                    matrix_d(347) or
                    matrix_d(346) or
                    matrix_d(345) or
                    matrix_d(344) or
                    matrix_d(343) or
                    matrix_d(342) or
                    matrix_d(341) or
                    matrix_d(340) or
                    matrix_d(339) or
                    matrix_d(338) or
                    matrix_d(337) or
                    matrix_d(336) or
                    matrix_d(335) or
                    matrix_d(334) or
                    matrix_d(333) or
                    matrix_d(332) or
                    matrix_d(331) or
                    matrix_d(330);

    blktag_d(14) <=     matrix_d(329) or
                        matrix_d(328) or
                        matrix_d(327) or
                        matrix_d(326) or
                        matrix_d(325) or
                        matrix_d(324) or
                        matrix_d(323) or
                        matrix_d(322) or
                        matrix_d(321) or
                        matrix_d(320) or
                        matrix_d(319) or
                        matrix_d(318) or
                        matrix_d(317) or
                        matrix_d(316) or
                        matrix_d(315) or
                        matrix_d(314) or
                        matrix_d(313) or
                        matrix_d(312) or
                        matrix_d(311) or
                        matrix_d(310) or
                        matrix_d(309) or
                        matrix_d(308);

    blktag_d(13) <=     matrix_d(307) or
                        matrix_d(306) or
                        matrix_d(305) or
                        matrix_d(304) or
                        matrix_d(303) or
                        matrix_d(302) or
                        matrix_d(301) or
                        matrix_d(300) or
                        matrix_d(299) or
                        matrix_d(298) or
                        matrix_d(297) or
                        matrix_d(296) or
                        matrix_d(295) or
                        matrix_d(294) or
                        matrix_d(293) or
                        matrix_d(292) or
                        matrix_d(291) or
                        matrix_d(290) or
                        matrix_d(289) or
                        matrix_d(288) or
                        matrix_d(287) or
                        matrix_d(286);

    blktag_d(12) <=     matrix_d(285) or
                        matrix_d(284) or
                        matrix_d(283) or
                        matrix_d(282) or
                        matrix_d(281) or
                        matrix_d(280) or
                        matrix_d(279) or
                        matrix_d(278) or
                        matrix_d(277) or
                        matrix_d(276) or
                        matrix_d(275) or
                        matrix_d(274) or
                        matrix_d(273) or
                        matrix_d(272) or
                        matrix_d(271) or
                        matrix_d(270) or
                        matrix_d(269) or
                        matrix_d(268) or
                        matrix_d(267) or
                        matrix_d(266) or
                        matrix_d(265) or
                        matrix_d(264);

    blktag_d(11) <=     matrix_d(263) or
                        matrix_d(262) or
                        matrix_d(261) or
                        matrix_d(260) or
                        matrix_d(259) or
                        matrix_d(258) or
                        matrix_d(257) or
                        matrix_d(256) or
                        matrix_d(255) or
                        matrix_d(254) or
                        matrix_d(253) or
                        matrix_d(252) or
                        matrix_d(251) or
                        matrix_d(250) or
                        matrix_d(249) or
                        matrix_d(248) or
                        matrix_d(247) or
                        matrix_d(246) or
                        matrix_d(245) or
                        matrix_d(244) or
                        matrix_d(243) or
                        matrix_d(242);

    blktag_d(10) <=     matrix_d(241) or
                        matrix_d(240) or
                        matrix_d(239) or
                        matrix_d(238) or
                        matrix_d(237) or
                        matrix_d(236) or
                        matrix_d(235) or
                        matrix_d(234) or
                        matrix_d(233) or
                        matrix_d(232) or
                        matrix_d(231) or
                        matrix_d(230) or
                        matrix_d(229) or
                        matrix_d(228) or
                        matrix_d(227) or
                        matrix_d(226) or
                        matrix_d(225) or
                        matrix_d(224) or
                        matrix_d(223) or
                        matrix_d(222) or
                        matrix_d(221) or
                        matrix_d(220);

    blktag_d(9) <=      matrix_d(219) or
                        matrix_d(218) or
                        matrix_d(217) or
                        matrix_d(216) or
                        matrix_d(215) or
                        matrix_d(214) or
                        matrix_d(213) or
                        matrix_d(212) or
                        matrix_d(211) or
                        matrix_d(210) or
                        matrix_d(209) or
                        matrix_d(208) or
                        matrix_d(207) or
                        matrix_d(206) or
                        matrix_d(205) or
                        matrix_d(204) or
                        matrix_d(203) or
                        matrix_d(202) or
                        matrix_d(201) or
                        matrix_d(200) or
                        matrix_d(199) or
                        matrix_d(198);

     blktag_d(8) <=     matrix_d(197) or
                        matrix_d(196) or
                        matrix_d(195) or
                        matrix_d(194) or
                        matrix_d(193) or
                        matrix_d(192) or
                        matrix_d(191) or
                        matrix_d(190) or
                        matrix_d(189) or
                        matrix_d(188) or
                        matrix_d(187) or
                        matrix_d(186) or
                        matrix_d(185) or
                        matrix_d(184) or
                        matrix_d(183) or
                        matrix_d(182) or
                        matrix_d(181) or
                        matrix_d(180) or
                        matrix_d(179) or
                        matrix_d(178) or
                        matrix_d(177) or
                        matrix_d(176);

    blktag_d(7) <=      matrix_d(175) or
                        matrix_d(174) or
                        matrix_d(173) or
                        matrix_d(172) or
                        matrix_d(171) or
                        matrix_d(170) or
                        matrix_d(169) or
                        matrix_d(168) or
                        matrix_d(167) or
                        matrix_d(166) or
                        matrix_d(165) or
                        matrix_d(164) or
                        matrix_d(163) or
                        matrix_d(162) or
                        matrix_d(161) or
                        matrix_d(160) or
                        matrix_d(159) or
                        matrix_d(158) or
                        matrix_d(157) or
                        matrix_d(156) or
                        matrix_d(155) or
                        matrix_d(154);

    blktag_d(6) <=      matrix_d(153) or
                        matrix_d(152) or
                        matrix_d(151) or
                        matrix_d(150) or
                        matrix_d(149) or
                        matrix_d(148) or
                        matrix_d(147) or
                        matrix_d(146) or
                        matrix_d(145) or
                        matrix_d(144) or
                        matrix_d(143) or
                        matrix_d(142) or
                        matrix_d(141) or
                        matrix_d(140) or
                        matrix_d(139) or
                        matrix_d(138) or
                        matrix_d(137) or
                        matrix_d(136) or
                        matrix_d(135) or
                        matrix_d(134) or
                        matrix_d(133) or
                        matrix_d(132);

    blktag_d(5) <=      matrix_d(131) or
                        matrix_d(130) or
                        matrix_d(129) or
                        matrix_d(128) or
                        matrix_d(127) or
                        matrix_d(126) or
                        matrix_d(125) or
                        matrix_d(124) or
                        matrix_d(123) or
                        matrix_d(122) or
                        matrix_d(121) or
                        matrix_d(120) or
                        matrix_d(119) or
                        matrix_d(118) or
                        matrix_d(117) or
                        matrix_d(116) or
                        matrix_d(115) or
                        matrix_d(114) or
                        matrix_d(113) or
                        matrix_d(112) or
                        matrix_d(111) or
                        matrix_d(110);

    blktag_d(4) <=  matrix_d(109) or
                    matrix_d(108) or
                    matrix_d(107) or
                    matrix_d(106) or
                    matrix_d(105) or
                    matrix_d(104) or
                    matrix_d(103) or
                    matrix_d(102) or
                    matrix_d(101) or
                    matrix_d(100) or
                    matrix_d(99) or
                    matrix_d(98) or
                    matrix_d(97) or
                    matrix_d(96) or
                    matrix_d(95) or
                    matrix_d(94) or
                    matrix_d(93) or
                    matrix_d(92) or
                    matrix_d(91) or
                    matrix_d(90) or
                    matrix_d(89) or
                    matrix_d(88);

    blktag_d(3) <=      matrix_d(87) or
                        matrix_d(86) or
                        matrix_d(85) or
                        matrix_d(84) or
                        matrix_d(83) or
                        matrix_d(82) or
                        matrix_d(81) or
                        matrix_d(80) or
                        matrix_d(79) or
                        matrix_d(78) or
                        matrix_d(77) or
                        matrix_d(76) or
                        matrix_d(75) or
                        matrix_d(74) or
                        matrix_d(73) or
                        matrix_d(72) or
                        matrix_d(71) or
                        matrix_d(70) or
                        matrix_d(69) or
                        matrix_d(68) or
                        matrix_d(67) or
                        matrix_d(66);

    blktag_d(2) <=      matrix_d(65) or
                        matrix_d(64) or
                        matrix_d(63) or
                        matrix_d(62) or
                        matrix_d(61) or
                        matrix_d(60) or
                        matrix_d(59) or
                        matrix_d(58) or
                        matrix_d(57) or
                        matrix_d(56) or
                        matrix_d(55) or
                        matrix_d(54) or
                        matrix_d(53) or
                        matrix_d(52) or
                        matrix_d(51) or
                        matrix_d(50) or
                        matrix_d(49) or
                        matrix_d(48) or
                        matrix_d(47) or
                        matrix_d(46) or
                        matrix_d(45) or
                        matrix_d(44);

    blktag_d(1) <=  matrix_d(43) or
                    matrix_d(42) or
                    matrix_d(41) or
                    matrix_d(40) or
                    matrix_d(39) or
                    matrix_d(38) or
                    matrix_d(37) or
                    matrix_d(36) or
                    matrix_d(35) or
                    matrix_d(34) or
                    matrix_d(33) or
                    matrix_d(32) or
                    matrix_d(31) or
                    matrix_d(30) or
                    matrix_d(29) or
                    matrix_d(28) or
                    matrix_d(27) or
                    matrix_d(26) or
                    matrix_d(25) or
                    matrix_d(24) or
                    matrix_d(23) or
                    matrix_d(22);

    blktag_d(0) <=      matrix_d(21) or
                        matrix_d(20) or
                        matrix_d(19) or
                        matrix_d(18) or
                        matrix_d(17) or
                        matrix_d(16) or
                        matrix_d(15) or
                        matrix_d(14) or
                        matrix_d(13) or
                        matrix_d(12) or
                        matrix_d(11) or
                        matrix_d(10) or
                        matrix_d(9) or
                        matrix_d(8) or
                        matrix_d(7) or
                        matrix_d(6) or
                        matrix_d(5) or
                        matrix_d(4) or
                        matrix_d(3) or
                        matrix_d(2) or
                        matrix_d(1) or
                        matrix_d(0);

end blocktag32_arch;

