--------------------------------------------------------
--
-- This is the dcm module which generates all clock signals used inside the DCC.
--
--
---------------------------------------------------------

library ieee,mylib;
use ieee.std_logic_1164.all;
use mylib.dfea_pack.all;

entity clocks is 
    port (
	   		clk_in		: in std_logic;
	   		reset			: in std_logic;
	   		clk			: out std_logic;
	   		clkn			: out std_logic;
	   		clk270		: out std_logic;
	   		lock			: out std_logic
           );

end clocks;

architecture clock_arch of clocks is 
attribute STARTUP_WAIT : string;
attribute STARTUP_WAIT of i_clock : label is "TRUE";
attribute CLK_FEEDBACK : string;
attribute CLK_FEEDBACK of i_clock: label is "1X";
signal clk_i: std_logic;
signal clk_dcm: std_logic;
signal clkn_dcm: std_logic;
signal clk270_dcm: std_logic;
signal clkin: std_logic;
begin
clk <= clk_i;
i_clock: dcm port map	
         ( CLKIN   => clkin ,
           CLKFB   => clk_i,
           RST     => reset,
           DSSEN   => gnd ,
           PSINCDEC=> gnd ,
           PSEN    => gnd ,
           PSCLK   => gnd ,
			  LOCKED    => lock,
			  CLK0    => clk_dcm,
           CLK180   => clkn_dcm,
           CLK270   => clk270_dcm
          );
i_clkin: ibufg port map ( o => clkin, i => clk_in);
i_clkbufg : BUFG port map (O=> clk_i, I=> clk_dcm);
i_clknbufg : BUFG port map (O=> clkn, I=> clkn_dcm);
i_clk270bufg : BUFG port map (O=> clk270, I=> clk270_dcm);
end clock_arch;

