--	Package File Template
--
--	Purpose: This package defines supplemental types, subtypes, 
--		 constants, and functions 


library IEEE;
use IEEE.STD_LOGIC_1164.all;

package dfea_pack is
constant vcc: std_logic := '1';
constant gnd: std_logic := '0';
constant gnd1: std_logic_vector(0 downto 0) := "0";
constant gnd2: std_logic_vector(1 downto 0) := "00";
constant gnd3: std_logic_vector(2 downto 0) := "000";
constant gnd4: std_logic_vector(3 downto 0) := "0000";
constant gnd5: std_logic_vector(4 downto 0) := "00000";
constant gnd6: std_logic_vector(5 downto 0) := "000000";
constant gnd7: std_logic_vector(6 downto 0) := "0000000";
constant gnd8: std_logic_vector(7 downto 0) := x"00";
constant gnd16: std_logic_vector(15 downto 0) := x"0000";
constant gnd32: std_logic_vector(31 downto 0) := x"00000000";
subtype vector6 is std_logic_vector(5 downto 0);
type array_x8y6 is array(7 downto 0) of vector6;
subtype vector16 is std_logic_vector(15 downto 0);
type array_x8y16 is array(7 downto 0) of vector16;
type array_x4y16 is array(3 downto 0) of vector16;
subtype vector3 is std_logic_vector(2 downto 0);
type array_x8y3 is array(7 downto 0) of vector3;
subtype vector4 is std_logic_vector(3 downto 0);
type array_x4y4 is array(3 downto 0) of vector4;
component BUFG 
  port (
  	I   : in std_logic;
        O    : out std_logic
	); 
end component;
--
component IBUFG 
  port (
  	I   : in std_logic;
        O    : out std_logic
	); 
end component;
component FDDRRSE
        port (
        d0 : in std_logic;
        d1 : in std_logic;
        c0 : in std_logic;
        c1 : in std_logic;
        ce : in std_logic;
        r  : in std_logic;
        s  : in std_logic;
        q  : out std_logic);
end component;
component SRLC16
  port (D   : in STD_logic;
        CLK : in STD_logic;
        A0  : in STD_logic;
        A1  : in STD_logic;
        A2  : in STD_logic;
        A3  : in STD_logic;
        Q   : out STD_logic; 
        Q15   : out STD_logic); 
end component;
component SRLC16E
  generic (
       INIT : bit_vector := X"0000");
  port (D   : in STD_logic;
        CE  : in STD_logic;
        CLK : in STD_logic;
        A0  : in STD_logic;
        A1  : in STD_logic;
        A2  : in STD_logic;
        A3  : in STD_logic;
        Q   : out STD_logic; 
        Q15   : out STD_logic); 
end component;
component DCM
    port ( CLKIN   : in  std_logic ;
           CLKFB   : in  std_logic ;
           RST     : in  std_logic ;
           DSSEN   : in  std_logic ;
           PSINCDEC: in  std_logic ;
           PSEN    : in  std_logic ;
           PSCLK   : in  std_logic ;
           CLK0    : out std_logic ;
           CLK90   : out std_logic ;
           CLK180  : out std_logic ;
           CLK270  : out std_logic ;
           CLK2X   : out std_logic ;
           CLK2X180: out std_logic ;
           CLKDV   : out std_logic ;
           CLKFX   : out std_logic ;
           CLKFX180: out std_logic ;
           LOCKED  : out std_logic ;
           STATUS  : out std_logic_vector(7 downto 0);
           PSDONE  : out std_logic );
end component;
COMPONENT BUFG_CLK0_FB_SUBM
  port ( 
        CLK_IN     : in std_logic;
        RST        : in std_logic;
		  CLKFB      : in std_logic;
        CLK1X_EXT  : out std_logic;
		  CLK1X_INT  : out std_logic;
        LOCK_EXT   : out std_logic;
		  LOCK_INT   : out std_logic
       );
end COMPONENT;
component BUFGDLL
		port (I : in std_logic; O : out std_logic);
end component; 
component RAMB16_S1_S1
     generic(
         write_mode_a: string := "NO_CHANGE"; -- write_first(default)/read_first/no_change
         init_b: bit_vector(0 downto 0) := "0";
         srval_b: bit_vector(0 downto 0) := "0";
         write_mode_b: string := "NO_CHANGE"; -- write_first(default)/read_first/no_change
         init_a: bit_vector(0 downto 0) := "0";
         srval_a: bit_vector(0 downto 0) := "0";
       INIT_00 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_01 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_02 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_03 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_04 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_05 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_06 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_07 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_08 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_09 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0A : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0B : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0C : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0D : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0E : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0F : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_10 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_11 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_12 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_13 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_14 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_15 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_16 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_17 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_18 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_19 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1A : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1B : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1C : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1D : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1E : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1F : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_20 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_21 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_22 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_23 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_24 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_25 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_26 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_27 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_28 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_29 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2A : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2B : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2C : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2D : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2E : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2F : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_30 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_31 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_32 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_33 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_34 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_35 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_36 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_37 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_38 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_39 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3A : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3B : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3C : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3D : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3E : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3F : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000");
     port(
         dia: in std_logic_vector(0 downto 0); 
         addra: in std_logic_vector(13 downto 0);
         clka: in std_logic; 
         ssra: in std_logic; 
         ena: in std_logic; 
         wea: in std_logic; 
         doa: out std_logic_vector(0 downto 0); 
         dib: in std_logic_vector(0 downto 0); 
         addrb: in std_logic_vector(13 downto 0);
         clkb: in std_logic; 
         ssrb: in std_logic; 
         enb: in std_logic; 
         web: in std_logic; 
         dob: out std_logic_vector(0 downto 0)); 
end component;
component RAMB16_S18_S18 
  generic (
       WRITE_MODE_A : string := "WRITE_FIRST";
       WRITE_MODE_B : string := "WRITE_FIRST";
       INIT_A : bit_vector  := X"00000";
       SRVAL_A : bit_vector := X"00000";

       INIT_B : bit_vector  := X"00000";
       SRVAL_B : bit_vector := X"00000";

       INITP_00 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_01 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_02 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_03 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_04 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_05 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_06 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_07 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_00 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_01 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_02 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_03 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_04 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_05 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_06 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_07 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_08 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_09 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0A : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0B : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0C : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0D : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0E : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_0F : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_10 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_11 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_12 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_13 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_14 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_15 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_16 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_17 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_18 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_19 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1A : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1B : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1C : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1D : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1E : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_1F : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_20 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_21 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_22 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_23 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_24 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_25 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_26 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_27 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_28 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_29 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2A : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2B : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2C : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2D : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2E : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_2F : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_30 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_31 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_32 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_33 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_34 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_35 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_36 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_37 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_38 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_39 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3A : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3B : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3C : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3D : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3E : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_3F : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000");

  port (DIA    : in STD_LOGIC_VECTOR (15 downto 0);
        DIB    : in STD_LOGIC_VECTOR (15 downto 0);
        DIPA    : in STD_LOGIC_VECTOR (1 downto 0);
        DIPB    : in STD_LOGIC_VECTOR (1 downto 0);
        ENA    : in STD_logic;
        ENB    : in STD_logic;
        WEA    : in STD_logic;
        WEB    : in STD_logic;
        SSRA   : in STD_logic;
        SSRB   : in STD_logic;
        CLKA   : in STD_logic;
        CLKB   : in STD_logic;
        ADDRA  : in STD_LOGIC_VECTOR (9 downto 0);
        ADDRB  : in STD_LOGIC_VECTOR (9 downto 0);
        DOA    : out STD_LOGIC_VECTOR (15 downto 0);
        DOB    : out STD_LOGIC_VECTOR (15 downto 0);
        DOPA    : out STD_LOGIC_VECTOR (1 downto 0);
        DOPB    : out STD_LOGIC_VECTOR (1 downto 0)
       ); 
end component;
component RAMB16_S18_S36
  generic (
       WRITE_MODE_A : string := "WRITE_FIRST";
       WRITE_MODE_B : string := "WRITE_FIRST";
       INIT_A : bit_vector  := X"00000";
       SRVAL_A : bit_vector := X"00000";

       INIT_B : bit_vector  := X"000000000";
       SRVAL_B : bit_vector := X"000000000";

       INITP_00 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_01 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_02 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_03 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_00 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_01 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_02 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_03 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000"
  );
  port (DIA    : in STD_LOGIC_VECTOR (15 downto 0);
        DIB    : in STD_LOGIC_VECTOR (31 downto 0);
        DIPA    : in STD_LOGIC_VECTOR (1 downto 0);
        DIPB    : in STD_LOGIC_VECTOR (3 downto 0);
        ENA    : in STD_logic;
        ENB    : in STD_logic;
        WEA    : in STD_logic;
        WEB    : in STD_logic;
        SSRA   : in STD_logic;
        SSRB   : in STD_logic;
        CLKA   : in STD_logic;
        CLKB   : in STD_logic;
        ADDRA  : in STD_LOGIC_VECTOR (9 downto 0);
        ADDRB  : in STD_LOGIC_VECTOR (8 downto 0);
        DOA    : out STD_LOGIC_VECTOR (15 downto 0);
        DOB    : out STD_LOGIC_VECTOR (31 downto 0);
        DOPA    : out STD_LOGIC_VECTOR (1 downto 0);
        DOPB    : out STD_LOGIC_VECTOR (3 downto 0)); 
end component;
component RAMB16_S36_S36
  generic (
       WRITE_MODE_A : string := "WRITE_FIRST";
       WRITE_MODE_B : string := "WRITE_FIRST";
       INIT_A : bit_vector  := X"000000000";
       SRVAL_A : bit_vector  := X"000000000";

       INIT_B : bit_vector  := X"000000000";
       SRVAL_B : bit_vector  := X"000000000";

       INITP_00 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_01 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_02 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INITP_03 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_00 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_01 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_02 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000";
       INIT_03 : bit_vector := X"0000000000000000000000000000000000000000000000000000000000000000"
  );
  port (DIA    : in STD_LOGIC_VECTOR (31 downto 0);
        DIB    : in STD_LOGIC_VECTOR (31 downto 0);
        DIPA    : in STD_LOGIC_VECTOR (3 downto 0);
        DIPB    : in STD_LOGIC_VECTOR (3 downto 0);
        ENA    : in STD_logic;
        ENB    : in STD_logic;
        WEA    : in STD_logic;
        WEB    : in STD_logic;
        SSRA   : in STD_logic;
        SSRB   : in STD_logic;
        CLKA   : in STD_logic;
        CLKB   : in STD_logic;
        ADDRA  : in STD_LOGIC_VECTOR (8 downto 0);
        ADDRB  : in STD_LOGIC_VECTOR (8 downto 0);
        DOA    : out STD_LOGIC_VECTOR (31 downto 0);
        DOB    : out STD_LOGIC_VECTOR (31 downto 0);
        DOPA    : out STD_LOGIC_VECTOR (3 downto 0);
        DOPB    : out STD_LOGIC_VECTOR (3 downto 0)); 
end component;
COMPONENT mveto_general
	PORT(
		mc : IN std_logic_vector(351 downto 0);
		hc : IN std_logic_vector(351 downto 0);
		nc : IN std_logic_vector(351 downto 0);
		lc : IN std_logic_vector(703 downto 0);
		ml : IN std_logic_vector(351 downto 0);
		hl : IN std_logic_vector(351 downto 0);
		nl : IN std_logic_vector(351 downto 0);
		ll : IN std_logic_vector(703 downto 0);
		mr : IN std_logic_vector(351 downto 0);
		hr : IN std_logic_vector(351 downto 0);
		nr : IN std_logic_vector(351 downto 0);
		lr : IN std_logic_vector(703 downto 0);          
		version : OUT std_logic_vector(15 downto 0);
		mcell : OUT std_logic_vector(351 downto 0);
		hcell : OUT std_logic_vector(351 downto 0);
		ncell : OUT std_logic_vector(351 downto 0);
		lcell : OUT std_logic_vector(703 downto 0)
		);
END COMPONENT;
component max_mveto
    port (
      min  : in  std_logic_vector (351 downto 0);
      mout : out std_logic_vector (351 downto 0)
      );
end component;
component high_mveto
    port (
      min  : in  std_logic_vector (351 downto 0);
      mout : out std_logic_vector (351 downto 0)
      );
end component;
component med_mveto
    port (
      min  : in  std_logic_vector (351 downto 0);
      mout : out std_logic_vector (351 downto 0)
      );
end component;
component low_mveto
    port (
      min  : in  std_logic_vector (703 downto 0);
      mout : out std_logic_vector (703 downto 0)
      );
end component;
COMPONENT clocks
	PORT(
		clk_in : IN std_logic;          
		reset : IN std_logic;          
		clk : OUT std_logic;
		clkn : OUT std_logic;
		clk270 : OUT std_logic;
		lock : OUT std_logic
		);
END COMPONENT;

COMPONENT read_in
	PORT(
		version : IN std_logic_vector(15 downto 0);
		link1 : IN std_logic_vector(27 downto 0);
		link1_clk : IN std_logic;
		link2 : IN std_logic_vector(27 downto 0);
		link2_clk : IN std_logic;
		link3 : IN std_logic_vector(27 downto 0);
		link3_clk : IN std_logic;
		link4 : IN std_logic_vector(27 downto 0);
		link4_clk : IN std_logic;
		clock : IN std_logic;
		clear : IN std_logic;
		u9 : IN std_logic;
		bus_cmd : IN std_logic;    
		lock : OUT std_logic;
		ctrl_bus : INOUT std_logic_vector(15 downto 0);      
		veto_vers : IN std_logic_vector(15 downto 0);
		eqs_vers : IN std_logic_vector(31 downto 0);
		diag : OUT std_logic_vector(3 downto 0);      
		reset : OUT std_logic;
		link1_out : OUT std_logic_vector(27 downto 0);
		link2_out : OUT std_logic_vector(27 downto 0);
		link3_out : OUT std_logic_vector(27 downto 0);
		link4_out : OUT std_logic_vector(27 downto 0);
		link1_array : OUT std_logic_vector(195 downto 0);
		link2_array : OUT std_logic_vector(195 downto 0);
		link3_array : OUT std_logic_vector(195 downto 0);
		link4_array : OUT std_logic_vector(195 downto 0)
		);
END COMPONENT;
COMPONENT ddr_demux
	PORT(
		clk : IN std_logic;
		clkn : IN std_logic;
		load : IN std_logic;
		ddr_link : IN std_logic_vector(27 downto 0);          
		q_a : OUT std_logic_vector(195 downto 0);
		q_b : OUT std_logic_vector(195 downto 0);
		link_a : OUT std_logic_vector(27 downto 0);
		link_b : OUT std_logic_vector(27 downto 0)
		);
END COMPONENT;
COMPONENT ddr_mux
	PORT(
		clk : IN std_logic;
		clkn : IN std_logic;
		link_a : IN std_logic_vector(27 downto 0);
		link_b : IN std_logic_vector(27 downto 0);          
		link_out : OUT std_logic_vector(27 downto 0)
		);
END COMPONENT;
COMPONENT lowpt_tracks
	PORT(
		link0_array : IN std_logic_vector(195 downto 0);
		link2_array : IN std_logic_vector(195 downto 0);
		link3_array : IN std_logic_vector(195 downto 0);
		link4_array : IN std_logic_vector(195 downto 0);
		link5_array : IN std_logic_vector(195 downto 0);
		link6_array : IN std_logic_vector(195 downto 0);          
		eqs_vers : OUT std_logic_vector(31 downto 0);          
		m : OUT std_logic_vector(703 downto 0)
		);
END COMPONENT;
COMPONENT medpt_tracks
	PORT(
		link0_array : IN std_logic_vector(195 downto 0);
		link2_array : IN std_logic_vector(195 downto 0);
		link3_array : IN std_logic_vector(195 downto 0);
		link4_array : IN std_logic_vector(195 downto 0);
		link5_array : IN std_logic_vector(195 downto 0);
		link6_array : IN std_logic_vector(195 downto 0);          
		a : OUT std_logic_vector(46 downto 3);
		b : OUT std_logic_vector(56 downto 5);
		c : OUT std_logic_vector(64 downto 9);
		d : OUT std_logic_vector(71 downto 14);
		e : OUT std_logic_vector(76 downto 21);
		f : OUT std_logic_vector(81 downto 28);
		g : OUT std_logic_vector(83 downto 38);
		h : OUT std_logic_vector(89 downto 44);
		eqs_vers : OUT std_logic_vector(31 downto 0);          
		m : OUT std_logic_vector(351 downto 0)
		);
END COMPONENT;
component highpt_tracks
            port (
                link0_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                link2_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                link3_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                link4_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                link5_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                link6_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                eqs_vers:  out std_logic_vector(31 downto 0);      -- high equation version and sector number
                m:  out std_logic_vector(351 downto 0)      -- matrix values out
            );
end component;
component maxpt_tracks
            port (
                link0_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                link2_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                link3_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                link4_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                link5_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                link6_array:  in  std_logic_vector(195 downto  0);     -- doublet layers in
                eqs_vers:   out std_logic_vector(31 downto 0);   -- max equation version and sector number
                m:  out std_logic_vector(351 downto 0)      -- matrix values out
            );
end component;
component backend
            port (
                matrix_d:   in	std_logic_vector(351 downto 0);      -- inputs for the matrix
                clock:      in 	std_logic;                           -- runs at 53MHz (except when loading)
                reset:      in 	std_logic;                           -- active low async
                load:       in 	std_logic;                           -- the crossing marker, delayed by n clk cycles.
                dbl_trk:    out std_logic;
                muon_trk:   out std_logic_vector(9 downto 0);
				ctoc_trk:	out std_logic_vector(9 downto 0)
             );
end component;
component backend32
            port (
                matrix_d:   in std_logic_vector(703 downto 0);      -- inputs for the matrix
                clock:      in std_logic;                           -- runs at 53MHz (except when loading)
                reset:      in std_logic;                           -- active low async
                load:       in std_logic;                           -- the crossing marker, delayed by n clk cycles.
                start:      out std_logic;
                dbl_trk:    out std_logic;
                muon_trk:   out std_logic_vector(10 downto 0);
				ctoc_trk:	out std_logic_vector(10 downto 0)
			);
end component;
COMPONENT aa_top
	PORT(
		clock : IN std_logic;
		clock_n : IN std_logic;
		reset : IN std_logic;
		r2a : IN std_logic;
		fx : IN std_logic;
		sync_gap : IN std_logic;
		l1 : IN std_logic;
		cft_reset : IN std_logic;
		u10 : IN std_logic;
		wr_mobo : IN std_logic;
		rd_mobo : IN std_logic;
		rd_input : IN std_logic;
		rd_muon : IN std_logic;
		rd_CTOC : IN std_logic;
		cap_l1 : IN std_logic;
		cap_l2 : IN std_logic;
		link_data : IN std_logic_vector(111 downto 0);
		mem_depth : IN std_logic_vector(8 downto 0);
		addr : IN std_logic_vector(9 downto 0);
		w_data : IN std_logic_vector(15 downto 0);
		start : IN std_logic;
		max_muon_trk : IN std_logic_vector(9 downto 0);
		high_muon_trk : IN std_logic_vector(9 downto 0);
		med_muon_trk : IN std_logic_vector(9 downto 0);
		low_muon_trk : IN std_logic_vector(10 downto 0);
		max_ctoc_trk : IN std_logic_vector(9 downto 0);
		high_ctoc_trk : IN std_logic_vector(9 downto 0);
		med_ctoc_trk : IN std_logic_vector(9 downto 0);
		low_ctoc_trk : IN std_logic_vector(10 downto 0);
		cphi : in array_x8y6;
		cluster : IN std_logic_vector(17 downto 0);
		doublet : IN std_logic_vector(2 downto 0);
		dbl_trk : IN std_logic;
		prev_trk : IN std_logic;
		next_trk : IN std_logic;          
		r_data : OUT std_logic_vector(15 downto 0);
		valid_trk : OUT std_logic;
		bad_fx : OUT std_logic;
		sg_err : OUT std_logic;
		locked : OUT std_logic;
		diag : OUT std_logic_vector(3 downto 0);
		home_trk : OUT std_logic;
		ctoc_out : OUT std_logic_vector(27 downto 0);
		muon_dat : OUT std_logic_vector(15 downto 0);
		muon_xe : OUT std_logic;
		muon_pe : OUT std_logic
		);
END COMPONENT;
-- default L2 pipe depth
constant L2pipe_depth: std_logic_vector(6 downto 0) := "0100100";
-- DFEA register address
-- reset board, MCB status
constant R_board_CSR: std_logic_vector(11 downto 0) := x"000";
-- ctrl bits delay
constant R_nrzc_dl: std_logic_vector(11 downto 0) := x"001";
-- fake and capture control register
constant R_fc_ctrl: std_logic_vector(11 downto 0) := x"002";
-- writes start FPGA reprogramming, reads get series number, FPGA INIT, DONE status
constant R_FPGA_CSR: std_logic_vector(11 downto 0) := x"003";
-- FPGA U7 configuration data
constant R_CONFU7: std_logic_vector(11 downto 0) := x"004";
-- FPGA U8 configuration data
constant R_CONFU8: std_logic_vector(11 downto 0) := x"005";
-- FPGA U9 configuration data
constant R_CONFU9: std_logic_vector(11 downto 0) := x"006";
-- FPGA U10 configuration data
constant R_CONFU10: std_logic_vector(11 downto 0) := x"007";
-- history registers
constant R_his_a: std_logic_vector(11 downto 0) := x"008";
constant R_his_b: std_logic_vector(11 downto 0) := x"009";
constant R_his_c: std_logic_vector(11 downto 0) := x"00a";
constant R_L2pipe_depth: std_logic_vector(11 downto 0) := x"00b";
-- U6 firmware version
constant R_version: std_logic_vector(11 downto 0) := x"00c";
constant R_tick: std_logic_vector(11 downto 0) := x"00d";
constant R_turn: std_logic_vector(11 downto 0) := x"00e";
constant R_display: std_logic_vector(11 downto 0) := x"00f";
-- Capture muon data
constant R_up_mu: std_logic_vector(11 downto 0) := x"010";
constant R_down_mu: std_logic_vector(11 downto 0) := x"018";
-- Capture L1 data
constant R_up_L1: std_logic_vector(11 downto 0) := x"020";
constant R_down_L1: std_logic_vector(11 downto 0) := x"030";
-- Capture CPS data
constant R_up_CPS: std_logic_vector(11 downto 0) := x"040";
constant R_down_CPS: std_logic_vector(11 downto 0) := x"060";
-- Capture CFT data
constant R_up_CFT: std_logic_vector(11 downto 0) := x"080";
-- motherboard interface registers
constant R_up_mobo: std_logic_vector(11 downto 0) := x"0b8";
-- Capture CFT data
constant R_down_CFT: std_logic_vector(11 downto 0) := x"0c0";
-- motherboard interface registers
constant R_down_mobo: std_logic_vector(11 downto 0) := x"0f8";
-- Capture input data
constant R_up_in: std_logic_vector(11 downto 0) := x"100";
constant R_down_in: std_logic_vector(11 downto 0) := x"140";
-- Fake data
constant R_up_Fake: std_logic_vector(11 downto 0) := x"180";
constant R_down_Fake: std_logic_vector(11 downto 0) := x"1c0";

end dfea_pack;
package body dfea_pack is
end dfea_pack;
